package hk.quantr.fs.Dialogs;

import hk.quantr.fs.Global;
import hk.quantr.fs.PExceptionDialog;
import hk.quantr.fs.PFSCommonLib;
import hk.quantr.fs.algorithm.PFSReadImageAlgorithm;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class ReadDialog extends javax.swing.JDialog implements Runnable {

	PFSReadImageAlgorithm pfsReadImageAlgorithm = new PFSReadImageAlgorithm();
	ReadDialog_TableModel readDialogTableModel = new ReadDialog_TableModel();
	ReadDialog_TableCellRenderer readDialogTableCellRenderer = new ReadDialog_TableCellRenderer();

	/**
	 * Creates new form ReadDialog2
	 */
	public ReadDialog(java.awt.Frame parent, String title, boolean modal) {
		super(parent, title, modal);
		initComponents();

		jtable1.getColumnModel().getColumn(0).setPreferredWidth(500);
		jtable1.getColumnModel().getColumn(1).setPreferredWidth(100);
		progressBar1.setVisible(false);

		jtable1.getColumnModel().getColumn(0).setCellRenderer(readDialogTableCellRenderer);
		jtable1.getColumnModel().getColumn(1).setCellRenderer(readDialogTableCellRenderer);
		jtable1.setRowHeight(20);

		setSize(640, 550);
		PFSCommonLib.centerDialog(this);
		new Thread(this).start();
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtable1 = new javax.swing.JTable();
        progressBar1 = new javax.swing.JProgressBar();
        controlPanel = new javax.swing.JPanel();
        infoLabel = new javax.swing.JLabel();
        showErrorOnlyCheckBox = new javax.swing.JCheckBox();
        pauseButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jPanel1.setLayout(new java.awt.BorderLayout());

        jtable1.setModel(readDialogTableModel);
        jScrollPane1.setViewportView(jtable1);

        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);
        jPanel1.add(progressBar1, java.awt.BorderLayout.SOUTH);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        controlPanel.add(infoLabel);

        showErrorOnlyCheckBox.setText("Show error only");
        controlPanel.add(showErrorOnlyCheckBox);

        pauseButton.setText("Pause");
        pauseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pauseButtonActionPerformed(evt);
            }
        });
        controlPanel.add(pauseButton);

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });
        controlPanel.add(closeButton);

        getContentPane().add(controlPanel, java.awt.BorderLayout.SOUTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void pauseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pauseButtonActionPerformed
		if (pauseButton.getText().equals("Pause")) {
			pauseButton.setText("Resume");
		} else {
			pauseButton.setText("Pause");
		}
    }//GEN-LAST:event_pauseButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
		closeButton.setEnabled(false);
		pfsReadImageAlgorithm.shouldStop = true;
		while (pauseButton.isVisible() && !pauseButton.getText().equals("Resume")) {
			try {
				Thread.currentThread().sleep(1000);
			} catch (Exception ex) {
				ex.printStackTrace();
				if (Global.GUI) {
					new PExceptionDialog(ex, Global.sessionNumber).setVisible(true);
				}
			}
		}
		this.setVisible(false);
    }//GEN-LAST:event_closeButtonActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JPanel controlPanel;
    private javax.swing.JLabel infoLabel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jtable1;
    private javax.swing.JButton pauseButton;
    private javax.swing.JProgressBar progressBar1;
    private javax.swing.JCheckBox showErrorOnlyCheckBox;
    // End of variables declaration//GEN-END:variables

	@Override
	public void run() {
		try {
			if (Global.GUI) {
				pfsReadImageAlgorithm.readPFS(this, this.jtable1, this.readDialogTableModel, this.jScrollPane1, this.progressBar1, this.pauseButton, this.infoLabel);
			} else {
				pfsReadImageAlgorithm.readPFS();
			}
			closeButton.setText("Finish");
		} catch (Exception ex) {
			ex.printStackTrace();
			if (Global.GUI) {
				new PExceptionDialog(ex, Global.sessionNumber).setVisible(true);
			}
		}
	}
}
